/*
 *  EDLWriter.h
 *  EDLApp
 *
 *  Created by Jerry on 1/23/05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __EDLWRITER__
#define __EDLWRITER__

// 
#define LOW_STRIDE 16
#define MID_STRIDE  8
#define HI_STRIDE   4

#include "hdLinkedList.h"
#include "AudioEvent.h"
#include "StagingBuffer.h"
#include "bufferwrite.h"

struct timeParts {
    char	hours;
    char	mins;
    char	secs;
    char	hunds;
};


class EDLWriter {
public:
    EDLWriter();
    ~EDLWriter();

public:
    void Init();
    
    bool LoadProject(const char* path);
    void LoadProjFiles(const char* path);
    
    bool NewFile(const char* filename);
    bool NewFiles(const char* filenameL, const char* filenameR);

    void GetTime(UINT64 samples, timeParts& tp);
    bool ProjectTimes(timeParts& start, timeParts& end);
    bool ProjectSize(INT64& sizeInBytes);
    bool doConvert(double& percentComplete);
    void Cancel() { cancelled = true; }
    
    void SetParams(char, char);
    long SampleRate() { return (badrate) ? 0 : samplerate; }
       
private:
    EDLRenderer     edlReader;
    RecordingBuffer fileWriter;
       
       
public:
    hdLinkedList    projFiles;      // working list of files
	EDL*            theEDL;         // current edl list
    AudioEvent*     recordEvent;
    
    hdFile*         curFile;
    hdFile*         compFile;
    
    ChanTypes       type;
    char            channels;
    DWORD           samplerate;
    char            width;
    char            stride;
    bool            cancelled;
	bool			badrate;
};


#endif