// hdLinkedList.h: interface for the hdLinkedList class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __hdLINKEDLIST__
#define __hdLINKEDLIST__

#include <time.h>

class hdListItem  
{
public:
	hdListItem();
	~hdListItem();

public:
	hdListItem* next;
	hdListItem* prev;

	hdListItem* getNext() const { return next; }
	hdListItem* getPrev() const { return prev; }

	// functions for hdLinkedList to call (only?)
	void _setNext(hdListItem* item) {next = item;}
	void _setPrev(hdListItem* item) {prev = item;}

	// member functions a sub-class should override
	virtual time_t 	GetLocation()			{return 0;}
	virtual int		compare(hdListItem*);

};


class hdLinkedList  
{
public:
	hdLinkedList();
	~hdLinkedList();

protected:
	int			count;
	hdListItem*	head;
	hdListItem* tail;

public:
	int			GetCount();

	hdListItem* getHead() { return head;}
	hdListItem* getTail() { return tail;}

	void		addBefore(hdListItem*,hdListItem*);		// inserts item before another
	void		addAfter(hdListItem*, hdListItem*);		// appends item after another
	hdListItem* addItem(hdListItem*);					// inserts using compare for placement
	void		deleteItem(hdListItem*);				// extract and delete item
	void		removeItem(hdListItem*);				// removes from list, but doesn't delete
	void		updateItem(hdListItem*);				// updates item's position in list (remove/add)
	void		removeAll();							// removes and deletes all items
};

#endif 